<template>
  <v-container class="mx-0 px-0">
    <page-title>
      Supervisores de {{ clientCompany.name }}
    </page-title>
    <page-content>
      <page-content-list-user>
        <template #buttons>
          <data-button
            class="mr-2 mt-1"
            button-name="Nuevo Supervisor"
            icon="mdi-plus-thick"
            @clicked="handleClick"
          />
          <data-button
            class="mr-2 mt-1"
            button-name="Plantilla"
            icon="mdi-file-table-outline"
          />
          <data-button
            class="mt-1"
            button-name="Carga masiva"
            icon="mdi-book-plus-multiple"
          />
        </template>
        <template #table>
          <search-table
            table-title="Supervisores"
            :headers="headers"
            :items="supervisors"
            :full-name="true"
            :page="page"
            :items-per-page="pageSize"
            :loading="loading"
            @selectRow="supervisorSelected"
            @eventPagination="paginator"
          >
            <div class="text-center">
              <v-pagination
                v-model="page"
                :length="Math.ceil(totalSupervisors/pageSize)"
                :total-visible="7"
              />
            </div>
          </search-table>
        </template>
      </page-content-list-user>
    </page-content>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import PageTitle from '~/components/PageTitle';
import PageContent from '~/components/PageContent';
import PageContentListUser from '~/components/PageContentListUser';
import SearchTable from '~/components/supervisor/SearchTable';

export default {
  name: 'ClientSupervisor',
  components: {
    SearchTable,
    PageTitle,
    PageContent,
    PageContentListUser,
  },
  data() {
    return {
      headers: [
        { text: 'Nombres Completos', align: 'start', value: 'full_name' },
        { text: 'Tipo de Documento', value: 'user.typeDocument' },
        { text: 'Número de Documento', value: 'user.document' },
        { text: 'Correo Electrónico', value: 'email' },
        { text: 'Número de Celular', value: 'phoneNumber' },
        { text: 'Estado', value: 'isBlocked' },
      ],
      clientCompany: {},
      pageSize: 10,
      page: 1,
    };
  },
  computed: {
    ...mapState({
      supervisors: state => state['client-supervisor'].supervisors,
      totalSupervisors: state => state['client-supervisor'].totalSupervisors,
      loading: state => state['client-supervisor'].loading,
    }),
  },
  async mounted() {
    await this.getAllClientSupervisors(parseInt(this.$route.query.p));
  },
  methods: {
    handleClick() {
      console.log(this.clientCompany.id);
      this.$router.push(`/supervisores-clientes/${this.clientCompany.id}/nuevo-supervisor`);
    },
    async getAllClientSupervisors(page = 1) {
      if (isNaN(page)) {
        this.page = 1;
      } else {
        this.page = page;
      }
      let params;
      if (Object.entries(this.$route.query).length === 0) {
        params = { page: this.page - 1, pagesize: this.pageSize /* search: searchI */ };
      } else { // If enter by query params.
        params = { page: this.page - 1, pagesize: this.pageSize, search: this.$route.query.s };
      }
      await this.getClientSupervisors({ id: this.$route.params.id, params });
      this.clientCompany = this.supervisors[0].clientCompany;
    },
    supervisorSelected(supervisorItem, row) {
      this.$router.push(`/supervisores-clientes/${supervisorItem.uuid}`);
    },
    async paginator(page) {
      await this.$router.push({ path: '/clientes', query: { p: page } });

      // Update the table, with paginator.
      this.page = page;
      await this.getAllClientSupervisors(page);
    },
    ...mapActions({
      getClientSupervisors: 'client-supervisor/getClientSupervisor',
    }),
  },
};
</script>
